package com.kexun.controller;


import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.kexun.common.utils.Result;
import com.kexun.entity.ReportFileEntity;
import com.kexun.service.ReportFileService;
import lombok.extern.java.Log;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.*;

import java.io.File;
import java.io.IOException;
import java.nio.file.Files;
import java.util.Base64;
import java.util.List;

@RestController
@RequestMapping("/admin/report")
@Log
public class ReportController {


    @Value("${report.file.xmlSourcePath}")
    private String filePath;


    @Value("${report.file.modelTargetPath}")
    private String modelPath;


    @Autowired
    private ReportFileService reportFileService;


    @GetMapping("reportFileList")
    public Result businessToDoList(@RequestParam String businessNum) {
        JSONObject resJson=new JSONObject();
        List<ReportFileEntity> list= reportFileService.QueryFileByNum(businessNum);
        resJson.put("report_file_list",list);

        return Result.success("ok",resJson);
    }
    @GetMapping("del")
    public Result del(@RequestParam Long id) {

        reportFileService.removeById(id);
        return Result.success();
    }


    @GetMapping("/download/{filename}")
    public Result downloadFile(@PathVariable("filename") String filename) throws IOException {
        String downFilePath = filePath+ filename;

        File file = new File(downFilePath);
        if (file.exists()) {
            byte[] fileContent = Files.readAllBytes(file.toPath());
            String base64 = Base64.getEncoder().encodeToString(fileContent);
            JSONObject resJson = new JSONObject();
            resJson.put("file", base64);
            return Result.success("ok", resJson);
        } else {

            return Result.error("文件不存在!");
        }

    }


    @GetMapping("/downloadMod/{modname}")
    public Result downloadMod(@PathVariable("modname") String modname) throws IOException {
        String downFilePath = modelPath+ modname;



        File file = new File(downFilePath);
        if (file.exists()) {

            byte[] fileContent = Files.readAllBytes(file.toPath());
            String base64 = Base64.getEncoder().encodeToString(fileContent);
            JSONObject resJson = new JSONObject();
            resJson.put("file", base64);
            return Result.success("ok", resJson);
        } else {

            return Result.error("文件不存在!");
        }

    }

//    @PostMapping("download")
//    public Result  download(@RequestParam String fileName)  {
//        System.out.println(fileName);
//        reportService.download(fileName);
//        return Result.success();
//    }

//    @PostMapping("downloadMod")
//    public Result  downloadMod(@RequestParam String fileName)  {
//        System.out.println(fileName);
//        reportService.downloadMod(fileName);
//        return Result.success();
//    }

    //原来的逻辑是新增，2024.1.2之后改为修改 如果没有文件，改为新增，方法需要重写
    @PostMapping("fileReportAdd")
    public Result fileReportAdd(@RequestBody String json)
    {
        JSONObject req = JSON.parseObject(json);
        ReportFileEntity reportFileEntity = new ReportFileEntity();
        reportFileEntity.setFileName(req.getString("file_name"));
        reportFileEntity.setFileNameXml(req.getString("fileNameXml"));
        reportFileEntity.setFileNameTxt(req.getString("fileNameTxt"));
        reportFileEntity.setFileNameModel(req.getString("fileModel"));
        reportFileService.save(reportFileEntity);
        return Result.success();
    }
}
